{-# LANGUAGE DeriveGeneric #-}
{-# LANGUAGE DerivingStrategies #-}
{-# LANGUAGE GeneralizedNewtypeDeriving #-}
{-# LANGUAGE LambdaCase #-}
{-# LANGUAGE OverloadedStrings #-}
{-# LANGUAGE PatternSynonyms #-}
{-# LANGUAGE StrictData #-}
{-# LANGUAGE NoImplicitPrelude #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}

-- Derived from AWS service descriptions, licensed under Apache 2.0.

-- |
-- Module      : Amazonka.MacieV2.Types.OriginType
-- Copyright   : (c) 2013-2023 Brendan Hay
-- License     : Mozilla Public License, v. 2.0.
-- Maintainer  : Brendan Hay
-- Stability   : auto-generated
-- Portability : non-portable (GHC extensions)
module Amazonka.MacieV2.Types.OriginType
  ( OriginType
      ( ..,
        OriginType_AUTOMATED_SENSITIVE_DATA_DISCOVERY,
        OriginType_SENSITIVE_DATA_DISCOVERY_JOB
      ),
  )
where

import qualified Amazonka.Core as Core
import qualified Amazonka.Data as Data
import qualified Amazonka.Prelude as Prelude

-- | Specifies how Amazon Macie found the sensitive data that produced a
-- finding. Possible values are:
newtype OriginType = OriginType'
  { fromOriginType ::
      Data.Text
  }
  deriving stock
    ( Prelude.Show,
      Prelude.Read,
      Prelude.Eq,
      Prelude.Ord,
      Prelude.Generic
    )
  deriving newtype
    ( Prelude.Hashable,
      Prelude.NFData,
      Data.FromText,
      Data.ToText,
      Data.ToByteString,
      Data.ToLog,
      Data.ToHeader,
      Data.ToQuery,
      Data.FromJSON,
      Data.FromJSONKey,
      Data.ToJSON,
      Data.ToJSONKey,
      Data.FromXML,
      Data.ToXML
    )

pattern OriginType_AUTOMATED_SENSITIVE_DATA_DISCOVERY :: OriginType
pattern OriginType_AUTOMATED_SENSITIVE_DATA_DISCOVERY = OriginType' "AUTOMATED_SENSITIVE_DATA_DISCOVERY"

pattern OriginType_SENSITIVE_DATA_DISCOVERY_JOB :: OriginType
pattern OriginType_SENSITIVE_DATA_DISCOVERY_JOB = OriginType' "SENSITIVE_DATA_DISCOVERY_JOB"

{-# COMPLETE
  OriginType_AUTOMATED_SENSITIVE_DATA_DISCOVERY,
  OriginType_SENSITIVE_DATA_DISCOVERY_JOB,
  OriginType'
  #-}
